﻿using System.ComponentModel.Composition;
using System.ComponentModel.Composition.Hosting;
using System.Reflection;

namespace MEFWithUnityInterceptionDemo
{
    /// <summary>
    /// Application
    /// </summary>
    public class Application : IApplication
    {
        [Import]
        public ILogger Logger { get; set; }

        public Application()
        {}

        /// <summary>
        /// 请注意这里的虚方法
        /// </summary>
        public virtual void Run()
        {
            //创建目录
            var catalog = new AssemblyCatalog(Assembly.GetExecutingAssembly());
            //创建组合容器
            var container = new CompositionContainer(catalog);
            //组合部件
            container.ComposeParts(this);
            //调用方法
            Logger.Write("Helloworld");           
        }      
    }
}
