﻿using System;
using System.Collections.Generic;
using Microsoft.Practices.Unity.InterceptionExtension;
using System.ComponentModel.Composition;

namespace MEFWithUnityInterceptionDemo
{
    /// <summary>
    /// 自定义拦截器
    /// </summary>
    public class Interceptor : IInterceptionBehavior
    {
        /// <summary>
        /// 导入日志对象
        /// </summary>
        [Import]
        public ILogger Logger { get; set; }

        public Interceptor()
        {
        }

        public IEnumerable<Type> GetRequiredInterfaces()
        {
            return Type.EmptyTypes;
        }

        public IMethodReturn Invoke(IMethodInvocation input, GetNextInterceptionBehaviorDelegate getNext)
        {
            IMethodReturn msg = null;

            //方法调用前
            Logger.Write("Hello World + Pre Calling");

           // 方法调用
            msg = getNext()(input, getNext);

            //调用后 
            Logger.Write("Hello World + Post Calling");

            return msg;
        }

        /// <summary>
        /// 指定是否拦截
        /// </summary>
        public bool WillExecute
        {
            get 
            { 
                return true; 
            }            
        }
    } 
  
}
