﻿using System;
using Microsoft.Practices.Unity;
using System.ComponentModel.Composition.Hosting;
using System.Reflection;
using MefContrib.Integration.Unity;
using Microsoft.Practices.Unity.InterceptionExtension;

namespace MEFWithUnityInterceptionDemo
{
    class Program
    {
        static void Main(string[] args)
        {
            // 创建unity容器
            var unityContainer = new UnityContainer();
            var assemblyCatalog = new AssemblyCatalog(Assembly.GetExecutingAssembly());

            //注册MefContrib提供拦截扩展
            unityContainer.AddNewExtension<CompositionIntegration>();
            //注册自定义的拦截器扩展
            unityContainer.AddNewExtension<Interception>();

            //在unity容器中注册类型，并指定拦截虚方法,指定拦截器为Interceptor
            unityContainer.RegisterType<IApplication, Application>(new Interceptor<VirtualMethodInterceptor>(), new InterceptionBehavior<Interceptor>());

            //配置MefContrib提供的组合拦截器
            CompositionIntegration integration = unityContainer.Configure<CompositionIntegration>();
            //指定需要组合的目录
            integration.Catalogs.Add(assemblyCatalog);

            //从容器中获取Application的实例
            IApplication app = unityContainer.Resolve<Application>();

            app.Run();

            Console.ReadLine();
        }
    }

  


  



  



   


   
}
